---
title: PaymentRequest.canMakePayment()
slug: Web/API/PaymentRequest/canMakePayment
tags:
  - API
  - Experimental
  - Method
  - Payment Request
  - Payment Request API
  - PaymentRequest
  - Reference
  - Secure context
  - canMakePayment
---
<p>{{securecontext_header}}{{APIRef("Payment Request API")}}</p>

<p><span class="seoSummary">The {{domxref("PaymentRequest")}} method <code><strong>canMakePayment()</strong></code> determines whether or not the request is configured in a way that is compatible with at least one payment method supported by the {{Glossary("user agent")}}.</span> You can call this before calling {{domxref("PaymentRequest.show", "show()")}} to provide a streamlined user experience when the user's browser can't handle any of the payment methods you accept.</p>

<p>For instance, you might call <code>canMakePayment()</code> to determine if the browser will let the user pay using Payment Request API, and if it won't, you could fall back to another payment method, or offer a list of methods that aren't handled by Payment Request API (or even provide instructions for paying by mail or by phone).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><code><em>paymentRequest</em>.canMakePayment()
    .then( <em>canPay</em> =&gt; { ... })
    .catch( <em>error</em> =&gt; { ... })

<em>canPay</em> = await <em>paymentRequest</em>.canMakePayment();</code>
</pre>

<h3 id="Returns">Returns</h3>

<p>A {{jsxref("Promise")}} to a {{jsxref("Boolean")}} that resolves to <code>true</code> if the user agent supports any of the payment methods supplied when instantiating the request using the {{domxref('PaymentRequest.PaymentRequest()','PaymentRequest')}} constructor. If the payment can't be processed, the promise receives a value of <code>false</code>.</p>

<div class="notecard note">
<p><strong>Note:</strong> If you call this too often, the browser may reject the returned promise with a <code>DOMException</code>.</p>
</div>

<h3 id="Parameters">Parameters</h3>

<p>None</p>

<h2 id="Examples">Examples</h2>

<p>In the following example, is <a href="https://rsolomakhin.github.io/samples/paymentrequest/can-make-payment/">excerpted from a demo</a> that asynchronously builds a <code>PaymentRequest</code> object for both Apple Pay and credit cards. It wraps the call to <code>canMakePayment()</code> in feature detection, and calls an appropriate callback depending on the resolution of the <code>Promise</code>.</p>

<pre class="brush:js">
async function initPaymentRquest() {
  const details = {
    total: {
      label: "Total",
      amount: {
        currency: "USD",
        value: "0.00",
      },
    },
  };

  const supportsApplePay = new PaymentRequest(
    [{ supportedMethods: "https://apple.com/apple-pay" }],
    details
  ).canMakePayment();

  // Supports Apple Pay?
  if (await supportsApplePay) {
    // show Apple Pay logo, for instance
    return;
  }

  // Otherwise... let's see if we can use basic card
  const supportsBasicCard = await new PaymentRequest(
    [{ supportedMethods: "basic-card" }],
    details
  ).canMakePayment();

  if (supportsBasicCard) {
    // show basic card support
    return;
  }

  // Otherwise, make payments using HTML form element
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Payment','#canmakepayment-method','canMakePayment()')}}</td>
   <td>{{Spec2('Payment')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.PaymentRequest.canMakePayment")}}</p>
</div>

<h2 id="See_Also">See Also</h2>

<ul>
 <li>{{domxref('PaymentRequest.show','PaymentRequest.show()')}}</li>
</ul>
